Bug 853541 (CVE-2012-2186)

Summary: CVE-2012-2186 Asterisk: Asterisk Manager User Unauthorized Shell Access
Product: [Other] Security Response Reporter: Kurt Seifried <kseifried>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: itamar, jeff, lmadsen, rbryant
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=moderate,public=20120830,reported=20120830,source=full-disclosure,cvss2=6.0/AV:N/AC:M/Au:S/C:P/I:P/A:P,epel-6/asterisk=affected,fedora-17/asterisk=affected,fedora-16/asterisk=affected
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-12-11 04:09:20 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 853543, 853545, 853546    
Bug Blocks:    

Description Kurt Seifried 2012-08-31 15:50:27 EDT
AST-2012-012

The AMI Originate action can allow a remote user to specify information that can
be used to execute shell commands on the system hosting Asterisk.  This can
result in an unwanted escalation of permissions, as the Originate action, which
requires the “originate” class authorization, can be used to perform actions that
would typically require the “system” class authorization.  Previous attempts to
prevent this permission escalation (AST-2011-006, AST-2012-004) have sought to
do so by inspecting the names of applications and functions passed in with the
Originate action and, if those applications/functions matched a predefined set of
values, rejecting the command if the user lacked the “system” class
authorization.  As reported by IBM X-Force Research, the “ExternalIVR”
application is not listed in the predefined set of values.  The solution for this
particular vulnerability is to include the “ExternalIVR” application in the set of
defined applications/functions that require “system” class authorization.

Unfortunately, the approach of inspecting fields in the Originate action against
known applications/functions has a significant flaw.  The predefined set of values
can be bypassed by creative use of the Originate action or by certain dialplan
configurations, which is beyond the ability of Asterisk to analyze at run-time.
Attempting to work around these scenarios would result in severely restricting the
applications or functions and prevent their usage for legitimate means.  As such,
any additional security vulnerabilities, where an application/function that would
normally require the “system” class authorization can be executed by users with
the “originate” class authorization, will not be addressed.  Instead, the 
READMESERIOUSLY.bestpractices.txt file has been updated to reflect that the AMI
Originate action can result in commands requiring the “system” class
authorization to be executed.  Proper system configuration can limit the impact of
such scenarios.

This was originally reported by Zubair Ashraf of IBM X-Force Research

http://downloads.asterisk.org/pub/security/AST-2012-012.pdf
http://downloads.asterisk.org/pub/security/AST-2012-012.1.8.diff
http://downloads.asterisk.org/pub/security/AST-2012-012.10.diff
Comment 1 Kurt Seifried 2012-08-31 16:00:33 EDT
Created asterisk tracking bugs for this issue

Affects: epel-6 [bug 853543]
Comment 2 Kurt Seifried 2012-08-31 16:01:26 EDT
Created asterisk tracking bugs for this issue

Affects: fedora-16 [bug 853545]
Comment 3 Kurt Seifried 2012-08-31 16:02:24 EDT
Created asterisk tracking bugs for this issue

Affects: fedora-17 [bug 853546]
Comment 4 Fedora Update System 2012-09-17 13:46:40 EDT
asterisk-1.8.15.1-1.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 5 Fedora Update System 2012-09-17 13:55:37 EDT
asterisk-10.7.1-2.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 6 Fedora Update System 2012-09-17 19:51:31 EDT
asterisk-10.7.1-2.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 7 Fedora Update System 2012-09-21 16:52:44 EDT
asterisk-1.8.15.1-1.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.